#include "Particle.h"
#include "partemitter.h"
#include <stdio.h>

#include <windows.h>
#include <GL\Gl.h>

CParticle::CParticle(CPartEmitter* pEmitter)
{
	m_pNext = NULL;
	m_pEmitter = pEmitter;
	m_clrColor[0] = m_clrColor[1] = m_clrColor[2] = m_clrColor[3] = 1.0f; // weiss, alpha = 1
	m_vPosition[0] = m_vPosition[1] = m_vPosition[2] = 0.0f;	// Ursprung
	m_vVelocity[0] = m_vVelocity[1] = m_vVelocity[2] = 0.0f;	// keine Geschwindigkeit
	m_fSize = 1.0f;
	m_fBirthday = pEmitter->m_fCurTime;
	m_fLifetime = 5.0f;
	m_bLife = true;
}

CParticle::~CParticle()
{

}

void CParticle::Set(VECTOR vPosition,VECTOR vVelocity,float clrColor[4],float fSize,float fLifetime)
{
	memcpy(m_vPosition,vPosition,sizeof(float)*3);
	memcpy(m_vVelocity,vVelocity,sizeof(float)*3);
	m_fSize = fSize; 
	memcpy(m_clrColor,clrColor,sizeof(float)*4);
	m_fLifetime = fLifetime; 
}

void CParticle::Update()
{
	if(m_pEmitter->m_fCurTime - m_fBirthday > m_fLifetime)
	{
		m_bLife= false ;// Partikel wird beim nchsten Schleifendruchlauf gelscht
		
		return;	// keine weiteren Updates mehr ntig
	}


	// neue Position anhand der Geschwindigkeit und der Zeit seit dem letzen
	// Update berechnen
	m_vPosition[0] += (m_vVelocity[0]*m_pEmitter->m_fFrameTime);
	m_vPosition[1] += (m_vVelocity[1]*m_pEmitter->m_fFrameTime);
	m_vPosition[2] += (m_vVelocity[2]*m_pEmitter->m_fFrameTime);
}

void CParticle::Render()
{
	glColor4fv(m_clrColor);	// Farbe des Partikel setzen

	glBegin(GL_QUADS);	// Begin der Zeichenoperation, zeichne Rechtecke
		//	oben rechts
		glTexCoord2i(1,1); 
		glVertex3f(m_vPosition[0]+m_fSize,m_vPosition[1]+m_fSize,m_vPosition[2]); 
		
		// oben links
		glTexCoord2i(0,1);
		glVertex3f(m_vPosition[0]-m_fSize,m_vPosition[1]+m_fSize,m_vPosition[2]); 
		
		// unten links
		glTexCoord2i(0,0); 
		glVertex3f(m_vPosition[0]-m_fSize,m_vPosition[1]-m_fSize,m_vPosition[2]);

		// unten rechts
		glTexCoord2i(1,0); 
		glVertex3f(m_vPosition[0]+m_fSize,m_vPosition[1]-m_fSize,m_vPosition[2]); 

	glEnd();	// Ende der Zeichenoperation		
}